/**************************************************
 *  LCD + Sensor
 *   I2C LCD and AM2302(1Wire Serial)
 *   PIC16F18313
 *************************************************/
#include "mcc_generated_files/mcc.h"
#include "lcd8x2_lib.h"
// ϐ`
int16_t Buffer[2];
uint8_t Flag;
char Line1[9], Line2[9];
// ֐vg
void GetSensor(int16_t * buf);
/******************************
 * ^C}0荞ݏ֐
 * 2b
 *****************************/
void TMR0_Process(void){
    Flag = 1;
}
/********* C֐ *****************************/
void main(void)
{
    SYSTEM_Initialize();
    // ^C}0@Callback֐`
    TMR0_SetInterruptHandler(TMR0_Process);
    // 荞݋        
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    lcd_init();                             // LCD
    /**** C[v ******************/
    while (1)
    {
        if(Flag == 1){                      // 2b
            D2_SetHigh();                   // ڈ
            Flag = 0;
            // ZTf[^擾 2
            GetSensor(Buffer);
            // ɕϊobt@Ɋi[
            sprintf(Line1, "T=%2.1f %c", Buffer[1]/10.0, 0xDF);
            sprintf(Line2, "H=%2.1f %%", Buffer[0]/10.0);
            // LCDWs
            lcd_cmd(0x80);              // 1sڎw
            lcd_str(Line1);
            lcd_cmd(0xC0);              // 2sڎw
            lcd_str(Line2);
            D2_SetLow();
        }
    }
}
/*******************************************
 *  AM2302 Get Data 
 *   5Byte HumiH+HumiL+TempH+TempL+Check
 ********************************************/
void GetSensor(int16_t * buf){
    uint8_t i, j, pos, DataByte[5];
    
    // Output StartPulse
    SDA_SetLow();    
    SDA_SetDigitalOutput();                 // o̓[h
    __delay_ms(2);                          // 2msec
    SDA_SetHigh();
    SDA_SetDigitalInput();                  // ̓[h 
    __delay_us(150);                        // ŏ̃pXXLbv
    while(SDA_GetValue() == 1);             // High̊ԑ҂
    // Get 40bit data 5 byte
    for(j=0; j<5; j++){                     // 5oCgJԂ
        DataByte[j] = 0;                    // f[^Zbg
        pos = 0x80;                         // ŏʃrbg
        for(i=0; i<8; i++){                 // 8rbgJԂ
            while(SDA_GetValue() == 0);     // Low50usec҂
            __delay_us(40);                 // 40usecXLbv          
            if(SDA_GetValue() == 1){        // 01̔
                DataByte[j] |= pos;         // 1̏ꍇZbg
                while(SDA_GetValue() == 1); // rbgI҂  
            }
            pos >>= 1;                      // ̃rbg
         }
    }
    // f[^ϊ 10{̒l̂܂
    *buf = (int16_t)(DataByte[0]*256 + DataByte[1]);
    buf++;
    if(DataByte[2] & 0x80)
        *buf = -1 * ((int16_t)((DataByte[2]&0x07F)*256+DataByte[3]));
    else
        *buf = (int16_t)((DataByte[2]&0x07F)*256+DataByte[3]);
}
