/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F18857
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.36 and above
        MPLAB 	          :  MPLAB X 6.00	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set ANZ aliases
#define ANZ_TRIS                 TRISBbits.TRISB0
#define ANZ_LAT                  LATBbits.LATB0
#define ANZ_PORT                 PORTBbits.RB0
#define ANZ_WPU                  WPUBbits.WPUB0
#define ANZ_OD                   ODCONBbits.ODCB0
#define ANZ_ANS                  ANSELBbits.ANSB0
#define ANZ_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define ANZ_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define ANZ_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define ANZ_GetValue()           PORTBbits.RB0
#define ANZ_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define ANZ_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define ANZ_SetPullup()          do { WPUBbits.WPUB0 = 1; } while(0)
#define ANZ_ResetPullup()        do { WPUBbits.WPUB0 = 0; } while(0)
#define ANZ_SetPushPull()        do { ODCONBbits.ODCB0 = 0; } while(0)
#define ANZ_SetOpenDrain()       do { ODCONBbits.ODCB0 = 1; } while(0)
#define ANZ_SetAnalogMode()      do { ANSELBbits.ANSB0 = 1; } while(0)
#define ANZ_SetDigitalMode()     do { ANSELBbits.ANSB0 = 0; } while(0)

// get/set ANY aliases
#define ANY_TRIS                 TRISBbits.TRISB1
#define ANY_LAT                  LATBbits.LATB1
#define ANY_PORT                 PORTBbits.RB1
#define ANY_WPU                  WPUBbits.WPUB1
#define ANY_OD                   ODCONBbits.ODCB1
#define ANY_ANS                  ANSELBbits.ANSB1
#define ANY_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define ANY_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define ANY_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define ANY_GetValue()           PORTBbits.RB1
#define ANY_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define ANY_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define ANY_SetPullup()          do { WPUBbits.WPUB1 = 1; } while(0)
#define ANY_ResetPullup()        do { WPUBbits.WPUB1 = 0; } while(0)
#define ANY_SetPushPull()        do { ODCONBbits.ODCB1 = 0; } while(0)
#define ANY_SetOpenDrain()       do { ODCONBbits.ODCB1 = 1; } while(0)
#define ANY_SetAnalogMode()      do { ANSELBbits.ANSB1 = 1; } while(0)
#define ANY_SetDigitalMode()     do { ANSELBbits.ANSB1 = 0; } while(0)

// get/set ANX aliases
#define ANX_TRIS                 TRISBbits.TRISB2
#define ANX_LAT                  LATBbits.LATB2
#define ANX_PORT                 PORTBbits.RB2
#define ANX_WPU                  WPUBbits.WPUB2
#define ANX_OD                   ODCONBbits.ODCB2
#define ANX_ANS                  ANSELBbits.ANSB2
#define ANX_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define ANX_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define ANX_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define ANX_GetValue()           PORTBbits.RB2
#define ANX_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define ANX_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define ANX_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define ANX_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define ANX_SetPushPull()        do { ODCONBbits.ODCB2 = 0; } while(0)
#define ANX_SetOpenDrain()       do { ODCONBbits.ODCB2 = 1; } while(0)
#define ANX_SetAnalogMode()      do { ANSELBbits.ANSB2 = 1; } while(0)
#define ANX_SetDigitalMode()     do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()              PORTCbits.RC7
#define RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define RC7_SetPullup()             do { WPUCbits.WPUC7 = 1; } while(0)
#define RC7_ResetPullup()           do { WPUCbits.WPUC7 = 0; } while(0)
#define RC7_SetAnalogMode()         do { ANSELCbits.ANSC7 = 1; } while(0)
#define RC7_SetDigitalMode()        do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/